"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSubsocialMutation = exports.useSubsocialQuery = void 0;
const react_query_1 = require("@tanstack/react-query");
const __1 = require("..");
const connection_1 = require("./connection");
function useSubsocialQuery(params, func, config, defaultConfig) {
    const mergedConfig = (0, __1.mergeQueryConfig)(config, defaultConfig);
    return (0, react_query_1.useQuery)([params.key, params.data], (0, __1.queryWrapper)(func, async () => {
        const api = await (0, connection_1.getSubsocialApi)();
        return { api };
    }), mergedConfig);
}
exports.useSubsocialQuery = useSubsocialQuery;
function useSubsocialMutation(wallet, transactionGenerator, config, defaultConfig) {
    const workerFunc = async (param) => {
        if (!wallet)
            throw new Error('You need to connect your wallet first!');
        const subsocialApi = await (0, connection_1.getSubsocialApi)();
        return (0, __1.createTxAndSend)(transactionGenerator, param, subsocialApi, { wallet, networkRpc: (0, connection_1.getConnectionConfig)().substrateUrl }, config, defaultConfig);
    };
    return (0, react_query_1.useMutation)(workerFunc, {
        ...(defaultConfig || {}),
        ...config,
        onSuccess: (0, __1.makeCombinedCallback)(defaultConfig, config, 'onSuccess'),
        onError: (0, __1.makeCombinedCallback)(defaultConfig, config, 'onError'),
    });
}
exports.useSubsocialMutation = useSubsocialMutation;
