import { QueryClient } from '@tanstack/react-query';
import { MutationConfig, QueryConfig, Transaction, WalletAccount } from './types';
export declare function queryWrapper<ReturnType, Data, AdditionalData>(func: (params: {
    data: Data;
} & AdditionalData) => Promise<ReturnType>, getAdditionalData: () => Promise<AdditionalData>): ({ queryKey }: any) => Promise<ReturnType>;
export declare function mergeQueryConfig<T, V>(config?: QueryConfig<any, any>, defaultConfig?: QueryConfig<T, V>): QueryConfig<T, V>;
export declare function createQueryInvalidation<Param>(client: QueryClient, key: string): (data?: Param | null, exact?: boolean) => void;
export declare function makeCombinedCallback(defaultConfig: any, config: any, attr: string): (...data: any[]) => void;
export interface TxCallbacksParams {
    summary: string;
    address: string;
    params: any;
    explorerLink?: string;
    error?: string;
}
declare let txCallbacks: {
    onBroadcast: ({ summary }: TxCallbacksParams) => void;
    onError: ({ error }: TxCallbacksParams) => void;
    onSuccess: ({ summary }: TxCallbacksParams) => void;
};
export declare const setupTxCallbacks: (callbacks: Partial<typeof txCallbacks>) => void;
export declare function createTxAndSend<Param, AdditionalParams>(transactionGenerator: (param: Param, additionalParams: AdditionalParams) => Promise<{
    tx: Transaction;
    summary: string;
}>, param: Param, additionalParams: AdditionalParams, txConfig: {
    wallet: WalletAccount;
    networkRpc?: string;
}, config?: MutationConfig<Param>, defaultConfig?: MutationConfig<Param>): Promise<string>;
export declare function sendTransaction<Param>(txInfo: {
    tx: Transaction;
    summary: string;
    wallet: WalletAccount;
    params: Param;
    networkRpc: string | undefined;
}, config?: MutationConfig<Param>, defaultConfig?: MutationConfig<Param>): Promise<string>;
export {};
