import { SubsocialApi } from '@subsocial/api';
import { UseMutationResult } from '@tanstack/react-query';
import { MutationConfig, QueryConfig, Transaction, WalletAccount } from '../types';
export declare type SubsocialParam<T> = {
    data: T;
} & {
    api: SubsocialApi;
};
export declare function useSubsocialQuery<ReturnValue, Data>(params: {
    key: string;
    data: Data | null;
}, func: (params: SubsocialParam<Data>) => Promise<ReturnValue>, config?: QueryConfig, defaultConfig?: QueryConfig<ReturnValue, Data>): import("@tanstack/react-query").UseQueryResult<ReturnValue, unknown>;
export declare function useSubsocialMutation<Param>(wallet: WalletAccount, transactionGenerator: (params: Param, api: SubsocialApi) => Promise<{
    tx: Transaction;
    summary: string;
}>, config?: MutationConfig<Param>, defaultConfig?: MutationConfig<Param>): UseMutationResult<string, Error, Param, unknown>;
